#! /usr/bin/env python
############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
###########################################################################
import getopt, sys
from pyGridWare.stub2python import *

DEBUG  = 5
def print_debug(msg, level=1, *l, **kw):
    if DEBUG >= level:
        for i in l:
            msg += '\n*\t' + str(i)
        for k,v in kw.items():
            msg += '\n**\t%s: %s' %(k,v)
        print 'Client(%d): %s' %(level,msg)

def displayHelp():
    sline = '-'*50
    print '%s\n%s%s\n%s' %(sline,(' '*15),'pyAkenti client',sline)
    print '''Arguments (Required to run):
    --help            (-h )          display this screen
    --gsi             (-g )          Use GSITCP from pyGlobus\n'''
    sys.exit(0)

def doCommandLine(kw):
    try:
        (opts, args) = getopt.getopt(sys.argv[1:], 'gh',
                                     ('gsi', 'help'))
    except getopt.GetoptError, e:
        print >>sys.stderr, sys.argv[0] + ': ' + str(e)
        sys.exit(-1)

    for opt, val in opts:
        if opt in [ '-h', '--help' ]:
            displayHelp()
        elif opt in ['-g', '--gsi']:
            kw['ssl'] = 2
        else:
            print sys.argv[0] + ': Usage error; try --help.'
            sys.exit(-1)
    return

def main():
    kw = {'ssl':0,
          'tracefile':sys.stdout}

    doCommandLine(kw)
    ws = Wsdl('akenti_service.wsdl')
    stg = StubGenerator()
    stubs = stg.generate_stub(ws)
    stubby = stubs[0]
    a = stubby(**kw)

    for op_name in stubby.op_requests.keys():
        argsX = eval('a.'+ op_name+'()')
        eval('a.'+ op_name+'()')
        print_debug('\n\nOperation: %s\nArgument Object: %s' %(op_name, argsX))
        for arg in argsX.__dict__:
             if arg == 'resource':
                 argsX.resource = 'resource'
             elif arg == 'cerfFilename':
                 argsX.cerfFilename = 'cert'
             elif arg == 'subjectDN':
                 argsX.subjectDN = 'subjectDN'
             elif arg == 'issuerDN':
                 argsX.issuerDN = 'issuerDN'
             else:
                 raise RuntimeError, 'what is this?'
        ret = eval('a.'+ op_name+'(argsX)')
        print_debug('RESPONSE: %s' %(ret), 1, **ret.__dict__)

if __name__ == '__main__':
    main()
